export declare enum ErrorCodes {
    OK = 0,
    CANCELLED = 1,
    UNKNOWN = 2,
    INVALID_ARGUMENT = 3,
    DEADLINE_EXCEEDED = 4,
    NOT_FOUND = 5,
    ALREADY_EXISTS = 6,
    PERMISSION_DENIED = 7,
    RESOURCE_EXHAUSTED = 8,
    FAILED_PRECONDITION = 9,
    ABORTED = 10,
    OUT_OF_RANGE = 11,
    UNIMPLEMENTED = 12,
    INTERNAL = 13,
    UNAVAILABLE = 14,
    DATA_LOSS = 15,
    UNAUTHENTICATED = 16
}
export declare class UnknownError extends Error {
    static readonly MESSAGE = "Unknown error.";
    readonly code: number;
    constructor(message?: string);
}
export declare class InvalidArgumentError extends Error {
    static readonly MESSAGE = "The client specified an invalid argument.";
    readonly code: number;
    constructor(message?: string);
}
export declare class DeadlineExceededError extends Error {
    static readonly MESSAGE = "The deadline expired before the operation could complete.";
    readonly code: number;
    constructor(message?: string);
}
export declare class NotFoundError extends Error {
    static readonly MESSAGE = "The requested item was not found.";
    readonly code: number;
    constructor(message?: string);
}
export declare class AlreadyExistsError extends Error {
    static readonly MESSAGE = "The item being created already exists.";
    readonly code: number;
    constructor(message?: string);
}
export declare class PermissionDeniedError extends Error {
    static readonly MESSAGE = "Insufficient permissions.";
    readonly code: number;
    constructor(message?: string);
}
export declare class UnauthenticatedError extends Error {
    static readonly MESSAGE = "Authentication required.";
    readonly code: number;
    constructor(message?: string);
}
export declare class ResourceExhaustedError extends Error {
    static readonly MESSAGE = "The server resource has been exhausted.";
    readonly code: number;
    constructor(message?: string);
}
export declare class FailedPreconditionError extends Error {
    static readonly MESSAGE = "The operation requested was rejected by the server.";
    readonly code: number;
    constructor(message?: string);
}
export declare class AbortedError extends Error {
    static readonly MESSAGE = "The operation was aborted.";
    readonly code: number;
    constructor(message?: string);
}
export declare class OutOfRangeError extends Error {
    static readonly MESSAGE = "The operation was attempted past the valid range.";
    readonly code: number;
    constructor(message?: string);
}
export declare class UnimplementedError extends Error {
    static readonly MESSAGE = "The operation is not implemented.";
    readonly code: number;
    constructor(message?: string);
}
export declare class InternalError extends Error {
    static readonly MESSAGE = "Internal server error.";
    readonly code: number;
    constructor(message?: string);
}
export declare class UnavailableError extends Error {
    static readonly MESSAGE = "The service is currently unavailable.";
    readonly code: number;
    constructor(message?: string);
}
export declare class DataLossError extends Error {
    static readonly MESSAGE = "Unrecoverable data loss or corruption.";
    readonly code: number;
    constructor(message?: string);
}
